#include "Boss.h"

//save regenerating the map
#define BOSS_Y_OFFSET 23
#define BOSS_SIGHT 15

#define BOSS_PROJECTILE_WIDTH 5
#define BOSS_PROJECTILE_HEIGHT 8

#define SHOT_POSITION_START 5
#define SHOT_POSITION_END 55

u8 mapHasBoss = FALSE;
u8 bossRedraw = TRUE;
u8 bossAlive = TRUE;
u8 bossHits = 0;

u8 shotPosition = 5;

Position bossPosition;

//handle the fact we decided to make the boss smaller then originally intended in the map editor
void initBoss()
{
    bossHits = 0;
    bossRedraw = TRUE;
    bossAlive = TRUE;
    bossPosition.y += BOSS_Y_OFFSET;
}

void drawBoss()
{   
    u16 scrolledXPosition = bossPosition.x - (tileScrollX*4);
    u8* bossMemory;

    //make sure that the enemy is on screen before drawing it
    if(scrolledXPosition < SCREEN_X)
    {
        //make sure the boss is alive
        if(bossRedraw && bossAlive)
        {
            //draw the specified enemy in the enemy graphic set
            bossMemory = cpct_getScreenPtr(CPCT_VMEM_START, bossPosition.x, bossPosition.y);
            cpct_drawSprite(G_boss, bossMemory, BOSS_WIDTH, BOSS_HEIGHT);
            bossRedraw = FALSE;
        }
    }                 
}

void logicBoss()
{
    u16 scrolledXPosition = bossPosition.x - (tileScrollX*4);
    u8 tileScrollAdjustment = 0;

    //make sure the boss is alive
    if(bossAlive)
    {
        //make sure the boss is onscreen
        if(scrolledXPosition < SCREEN_X)
        {
            if(bossPosition.x + BOSS_SIGHT > playerShip.object.position.x + tileScrollAdjustment &&
                bossPosition.x - BOSS_SIGHT < playerShip.object.position.x + playerShip.object.width + tileScrollAdjustment)
            {
                //bossY within top boundry of shipY, bossY within bottom boundry of shipY 
                if(bossPosition.y + BOSS_HEIGHT + BOSS_SIGHT*2 > playerShip.object.position.y &&
                bossPosition.y - BOSS_SIGHT*2 < playerShip.object.position.y + playerShip.object.height)
                {
                    //shoot at the player
                    shootBoss();
                }
            }
        }
    }
    
}

void killBoss()
{    
    if(bossAlive)
    {
        u8* bossMemory = cpct_getScreenPtr(CPCT_VMEM_START, bossPosition.x, bossPosition.y);
        cpct_drawSolidBox(bossMemory, backgroundColour, BOSS_WIDTH, BOSS_HEIGHT);
    
        bossAlive = FALSE;
        bossRedraw = FALSE;
        addToScore(&gameHud, BOSS_SCORE);        
    }
}

void shootBoss()
{
    if(enemyProjectileTimerReady)
    {
        Projectile projectile;
        projectile.object.position.x = bossPosition.x - BOSS_PROJECTILE_WIDTH;
        projectile.object.position.y = bossPosition.y + shotPosition;
        projectile.direction = LEFT;
        projectile.parent = ENEMYPROJECTILE;            
        initProjectile(&projectile);

        //boss projectiles are bigger
        projectile.object.width = BOSS_PROJECTILE_WIDTH;
        projectile.object.height = BOSS_PROJECTILE_HEIGHT;
        
        addListItemCopy(&projectileList, &projectile, sizeof(Projectile)); 
        enemyProjectileTimerReady = FALSE;

        shotPosition += 5;
        if(shotPosition >= SHOT_POSITION_END)
        {
            shotPosition = SHOT_POSITION_START;
        }
    }    
}