#ifndef ENEMY_H
#define ENEMY_H

#include <cpctelera.h>
#include "Object.h"
#include "Lists.h"
#include "Projectile.h"
#include "Timer.h"
#include "Map.h"
#include "sprites/enemy_sprites.h"

#define ENEMY_COMPONENT_COUNT 7

#define ENEMY_WIDTH_BYTES 3
#define ENEMY_HEIGHT 12

typedef struct Enemy Enemy;
typedef enum Enemy_t EnemyType;

enum Enemy_t
{
    TURRET,
    FLYING_REPEAT,
    FLYING_AND_OFF
};

struct Enemy
{
    Object object;
    EnemyType type;
    Position previousPosition;
    u8* path;
    u8 pathSteps;
    u8 currentStep;
    i8 pathTravelDirection;
    u16 score;
	u8 destroyed;
    u8 spriteNumber;
    u8 enemySpawnTime;
};

void initEnemy(Enemy* enemy, EnemyType type, u16 x, u8 y, u8 width, u8 height);

//draw enemy to screen
void drawEnemy(Enemy* enemy);

//logic for enemy
void logicEnemy(Enemy* enemy, Object* shipObject);

//enemy shooting function spawns projectiles
void shootEnemy(Enemy* enemy);

//remove enemy from the screen
void clearEnemy(Enemy* enemy);

#endif