#ifndef HUD_H
#define HUD_H

#include <cpctelera.h>
#include "GameTypes.h"
#include "Ship.h"
#include "sprites/hud_sprites.h"
#include "Map.h"

//this is the HUD at the bottom of the screen that displays current information to the player about 
//their state and the general game state.

typedef struct Hud Hud;

struct Hud
{    
    u16 gameScore;
    u8 redraw;
    void (*drawHud)(Hud*);    
};

//setup the hud
void initHud(Hud* hud);

//adds to the gamescore that is displayed on the hud
void addToScore(Hud* hud, u16 addedScore);

extern Hud gameHud;

//we use this to display the score on the hud and on the victory/game over screen
extern u8 scoreHud[6];

void convertIntToChar(u16 input, u8 output[6]);

#endif