#include "LinkedList.h"

void addListItemCopy(LinkedList** list, void* data, u8 dataSize)
{
	Node* currentNode = *list;
	Node* newNode = NULL;

	//add an item to an empty list
	if ((*list) == NULL)
	{
		(*list) = malloc(sizeof(Node));
		
		(*list)->data = malloc(dataSize);
		cpct_memcpy((*list)->data, data, dataSize);

		(*list)->prev = NULL;
		(*list)->next = NULL;
	}
	else
	{		
		while (currentNode->next != NULL)
		{
			currentNode = currentNode->next;
		}

		newNode = malloc(sizeof(Node));

		newNode->data = malloc(dataSize);
		cpct_memcpy(newNode->data, data, dataSize);
		//newNode->data = data;
		newNode->next = NULL;
		newNode->prev = currentNode;
		currentNode->next = newNode;
	}
}

void removeListItemCopy(LinkedList** list, void* data)
{
	Node* currentNode = *list;

	while (currentNode != NULL)
	{
		if (currentNode->data == data)
		{
			//removing the first element from the list
			if (*list == currentNode)
			{
				if ((*list)->next != NULL)
				{
					(*list) = (*list)->next;
					(*list)->prev = NULL;
				}
				//removing the first element from a list that contains only one item
				else
				{
					(*list) = NULL;
				}
			} 
			//removing the last element from the list			
			else if (currentNode->next == NULL)
			{
				currentNode->prev->next = NULL;
			}
			else
			{
				//point previous items next to the currents next
				currentNode->prev->next = currentNode->next;

				//point next items previous to the currents previous
				currentNode->next->prev = currentNode->prev;
			}

			//free the memory for the node being removed
			free(currentNode->data);
			free(currentNode);

			break;
		}

		currentNode = currentNode->next;
	}

}

void* listItemAt(LinkedList** list, const u8 position)
{
	Node* currentNode = *list;
	u8 currentPosition = 0;

	while (currentNode != NULL)
	{
		if (currentPosition == position)
		{
			return currentNode->data;
		}

		currentNode = currentNode->next;
		++currentPosition;
	}

	return NULL;
}

const u8 listItemCount(LinkedList** list)
{	
	Node* currentNode = *list;
	u8 count = 0;

	while (currentNode != NULL)
	{	
		currentNode = currentNode->next;
		++count;
	}

	return count;
}

void clearList(LinkedList** list)
{
	Node* currentNode = *list;
	
	if (currentNode != NULL)
	{
		//iterate through the list freeing memory as it goes
		while (currentNode->next != NULL)
		{
			currentNode = currentNode->next;
			currentNode->prev->next = NULL;
			free(currentNode->prev->data);
			free(currentNode->prev);
			currentNode->prev = NULL;
		}

		//free the last element
		free(currentNode->data);
		free(currentNode);
		*list = NULL;
	}
}