#ifndef LINKEDLIST_H
#define LINKEDLIST_H

#include <stdlib.h>
#include <cpctelera.h>

//this is an implementation of a doubly linked list
//each element of the list has a reference to the previous element and the next element 

typedef struct Node LinkedList;
typedef struct Node Node;

struct Node
{
	void* data;
	Node* prev;
	Node* next;
};

//add a new item to the end of the list
void addListItemCopy(LinkedList** list, void* data, u8 dataSize);

//remove the specified item from the list
void removeListItemCopy(LinkedList** list, void* data);

//return the item at the specified position from the list
void* listItemAt(LinkedList** list, const u8 position);

//return the total number of items from the list
const u8 listItemCount(LinkedList** list);

//remove all the items from the list
void clearList(LinkedList** list);

#endif