#ifndef MAP_H
#define MAP_H

#include <Types.h>
#include "GameTypes.h"
#include "maps/Maps.h"
#include "LinkedList.h"
#include "Enemy.h"
#include "PowerUp.h"
#include "PowerWell.h"
#include "Palettes.h"
#include "Boss.h"

#define POWERUP_COMPONENT_COUNT 3
#define POWERWELL_COMPONENT_COUNT 4

//used for accessing the map array throughout the code
extern u8* mapArray;
extern u8* enemySpawnsArray;
extern u8* powerupArray;
extern u8 mapRedraw;
extern u8 mapXTileCount;
extern u8 powerwellCount;
extern i8 levelEnd;

//ship position from map_
extern i8 mapShipXPosition;
extern i8 mapShipYPosition;

//draw the current map
void initMap(const u8 selectedLevel);
void drawMap();

void chooseMap(const u8 selectedLevel);
void initEnemies();

void initPowerUps();

void initPowerWells();

void destroyMap();

#endif