#include "PowerUp.h"

void drawPowerUp(PowerUp* powerup)
{   
    u8* powerupVideoMemory;
    u16 scrolledXPosition = powerup->object.position.x - (tileScrollX*4);   

    //make sure that the powerup is on screen before drawing it
    if(scrolledXPosition < SCREEN_X)
    {
        //only draw the powerup when it needs to be redrawn
        if(powerup->redraw)
        {
            //draw a box to represent a powerup
            powerupVideoMemory = cpct_getScreenPtr(CPCT_VMEM_START, powerup->object.position.x, powerup->object.position.y);

            switch(powerup->type)
            {
                case SPEED:
                {
                    cpct_drawSprite(G_speed_powerup, powerupVideoMemory, powerup->object.width, powerup->object.height);
                }
                break;

                case POWER:
                {
                    cpct_drawSprite(G_power_powerup, powerupVideoMemory, powerup->object.width, powerup->object.height);
                }
                break;

                case EXTRALIFE:
                {
                    cpct_drawSprite(G_health_powerup, powerupVideoMemory, powerup->object.width, powerup->object.height);
                }
                break;
            }  
        }              
    }    
}

void clearPowerUp(PowerUp* powerup)
{
    u8* powerupVideoMemory = cpct_getScreenPtr(CPCT_VMEM_START, powerup->object.position.x, powerup->object.position.y);
    cpct_drawSolidBox(powerupVideoMemory, backgroundColour, powerup->object.width, powerup->object.height);  
}