#ifndef POWERUP_H
#define POWERUP_H

#include <cpctelera.h>
#include "Object.h"
#include "GameTypes.h"
#include "Mediator.h"
#include "sprites/powerup_sprites.h"

#define POWERUP_WIDTH_BYTES 4
#define POWERUP_HEIGHT 8

typedef struct PowerUp PowerUp;

typedef enum 
{ 
    SPEED,
    POWER,
    EXTRALIFE
} 
PowerUpType;

struct PowerUp
{
    Object object;
    PowerUpType type;
    u8 used;
    u8 score;
    u8 redraw;
};

void drawPowerUp(PowerUp* powerup);

void clearPowerUp(PowerUp* powerup);

#endif