#ifndef POWERWELL_H
#define POWERWELL_H

#include <cpctelera.h>
#include "GameTypes.h"
#include "Object.h"
#include "Ship.h"
#include "PowerWellAttack.h"
#include "sprites/powerwell_sprites.h"

typedef struct PowerWell PowerWell;

typedef enum 
{
    POSITIVE,
    NEGATIVE
}
PowerWellType;

struct PowerWell
{
    Object object;
    PowerWellType type;
    u8 destroyed;
    void (*logicPowerWell)(PowerWell*, Object*);
    PowerWellAttack attack;
    u8 score;
    u8 hitCount;
};

#define POWERWELL_DEFAULT_LIFE 11
#define POWERWELL_SCORE 300

void initPowerWell(PowerWell* powerwell, u16 x, u16 y, u8 width, u8 height, PowerWellType type);
void drawPowerWell(PowerWell* powerwell);
void clearPowerWell(PowerWell* powerwell);

#endif