#ifndef PROJECTILE_H
#define PROJECTILE_H

#include <cpctelera.h>
#include "Object.h"
#include "GameTypes.h"
#include "Enemy.h"
#include "Hud.h"
#include "Mediator.h"
#include "Boss.h"

//This is used for moving projectiles.
//Projectiles are created when a ship or enemy shoots at something.

typedef struct Projectile Projectile;

typedef enum
{
    SHIPPROJECTILE,
    ENEMYPROJECTILE
}
ParentType;

struct Projectile
{
    Object object;
    Position previousPosition;
    u8 direction;
    ParentType parent; 
	u8 destroyed;
};

void initProjectile(Projectile* projectile);

//draw the projectile to the screen
void drawProjectile(Projectile* projectile);

//projectile related logic
void logicProjectile(Projectile* projectile);

void shootProjectile(Projectile* projectile);

//clear projectile from the screen
void clearProjectile(Projectile* projectile);

#endif