#ifndef SHIP_H
#define SHIP_H

#include <cpctelera.h>
#include "Object.h"
#include "GameTypes.h"
#include "sprites/ship_sprite.h"
#include "Map.h"
#include "Hud.h"
#include "Mediator.h"
#include "Difficulty.h"

typedef struct Ship Ship;

#define SHIP_WIDTH_BYTES 6
#define SHIP_HEIGHT 8

struct Ship
{
    Object object;    
    Position previousPosition;   
    u8 lifeCount;
    u8 power;   
    u8 shipSpeed;
    u8 direction;
    u8 flippedDirection;
    u8 reachedLevelEnd;
    void (*shootProjectile)(Ship*);
};

extern u8 previousLifeCount;
extern Ship playerShip;

//move the ship in the direction specified, updating the velocity
void moveShip(u8 direction);
void initShip();
void drawShip();
void logicShip();

#endif