#ifndef UNDERWATER02_H
#define UNDERWATER02_H

#include "../sprites/Sprites.h"
#include "../Mediator.h"
#include "../GameTypes.h"
#include "../MemoryManager.h"
#include <cpctelera.h>

#define UNDERWATER02_ENEMY_COUNT 5

#define UNDERWATER02_POWERUP_COUNT 1

#define UNDERWATER02_POWERWELL_COUNT 2

#define UNDERWATER02_X_TILE_COUNT 50

#define UNDERWATER02_BACKGROUND_COLOUR_1 5
#define UNDERWATER02_BACKGROUND_COLOUR_2 5
#define UNDERWATER02_BORDER_COLOUR 20
#define UNDERWATER02_PALETTE 1
#define UNDERWATER02_LEVEL_END 50

#ifdef UNDERWATER02_CONTAINS_BOSS 
	#define UNDERWATER02_BOSS_X -1
	#define UNDERWATER02_BOSS_Y -1
#endif

#define UNDERWATER02_SHIP_X 1
#define UNDERWATER02_SHIP_Y 6

extern const u8 map_underwater02[600];

#ifdef UNDERWATER02_ENEMY_COUNT
extern const u8 enemy_spawns_paths_underwater02[32];
extern const u8 enemy_spawns_underwater02[35];
#endif

#ifdef UNDERWATER02_POWERUP_COUNT
extern const u8 powerups_underwater02[3];
#endif

#ifdef UNDERWATER02_POWERWELL_COUNT
extern const u8 powerwells_underwater02[8];
#endif

#endif
