#include "HighScoresMenu.h"

#define HIGHSCORES_MENU_TITLE_TEXT_LENGTH_ 12
#define NAME_STRING_LENGTH_ 4
#define SCORE_STRING_LENGTH_ 6
#define TITLE_Y_POSITION 10
#define NAME_X_POSITON_ 14
#define SCORE_X_POSITION_ 30
#define FIRST_Y_POSITION_ 30
#define SECOND_Y_POSITION_ 40
#define THIRD_Y_POSITION_ 50

const u8 HIGHSCORES_MENU_TITLE_TEXT_[HIGHSCORES_MENU_TITLE_TEXT_LENGTH_] = "High Scores\0";

u8 firstName_[NAME_STRING_LENGTH_];
u8 secondName_[NAME_STRING_LENGTH_];
u8 thirdName_[NAME_STRING_LENGTH_];
u8 firstScore_[SCORE_STRING_LENGTH_];
u8 secondScore_[SCORE_STRING_LENGTH_];
u8 thirdScore_[SCORE_STRING_LENGTH_];

u16 firstScoreNum_;
u16 secondScoreNum_;
u16 thirdScoreNum_;

void buildHighScores()
{
    //populate the initial scores and names
    memcpy(firstName_, "CPC\0", NAME_STRING_LENGTH_);
    memcpy(secondName_, "CPC\0", NAME_STRING_LENGTH_);
    memcpy(thirdName_, "CPC\0", NAME_STRING_LENGTH_);

    firstScoreNum_ = 300;
    secondScoreNum_ = 200;
    thirdScoreNum_ = 100;
}


void displayHighScores()
{
    u8* highScoreMemory;

    cpct_clearScreen(0x00);

    //convert u16s to strings to display on the screen
    convertIntToChar(firstScoreNum_, firstScore_);
    convertIntToChar(secondScoreNum_, secondScore_);
    convertIntToChar(thirdScoreNum_, thirdScore_);

    //title
    highScoreMemory = cpct_getScreenPtr(CPCT_VMEM_START, NAME_X_POSITON_, TITLE_Y_POSITION);
    cpct_drawStringM0(HIGHSCORES_MENU_TITLE_TEXT_, highScoreMemory, 1, 5);  

    //first score
    highScoreMemory = cpct_getScreenPtr(CPCT_VMEM_START, NAME_X_POSITON_, FIRST_Y_POSITION_);
    cpct_drawStringM0(firstName_, highScoreMemory, 1, 0);

    highScoreMemory = cpct_getScreenPtr(CPCT_VMEM_START, SCORE_X_POSITION_, FIRST_Y_POSITION_);
    cpct_drawStringM0(firstScore_, highScoreMemory, 1, 0);

    //second score
    highScoreMemory = cpct_getScreenPtr(CPCT_VMEM_START, NAME_X_POSITON_, SECOND_Y_POSITION_);
    cpct_drawStringM0(secondName_, highScoreMemory, 1, 0);
    
    highScoreMemory = cpct_getScreenPtr(CPCT_VMEM_START, SCORE_X_POSITION_, SECOND_Y_POSITION_);
    cpct_drawStringM0(secondScore_, highScoreMemory, 1, 0);  

    //third score
    highScoreMemory = cpct_getScreenPtr(CPCT_VMEM_START, NAME_X_POSITON_, THIRD_Y_POSITION_);
    cpct_drawStringM0(thirdName_, highScoreMemory, 1, 0);
    
    highScoreMemory = cpct_getScreenPtr(CPCT_VMEM_START, SCORE_X_POSITION_, THIRD_Y_POSITION_);
    cpct_drawStringM0(thirdScore_, highScoreMemory, 1, 0);

    //wait for user to press any key before going back to menu
    while(1)
    {
        cpct_scanKeyboard();

        if(cpct_isKeyPressed(Key_Return))
        {
            break;
        }
    }
}

void updateHighScore()
{
    if(gameHud.gameScore > firstScoreNum_)
    {
        thirdScoreNum_ = secondScoreNum_;
        secondScoreNum_ = firstScoreNum_;
        firstScoreNum_ = gameHud.gameScore;

        memcpy(thirdName_, secondName_, NAME_STRING_LENGTH_);
        memcpy(secondName_, firstName_, NAME_STRING_LENGTH_);        
        memcpy(firstName_, newScoreName, NAME_STRING_LENGTH_);

    }
    else if(gameHud.gameScore > secondScoreNum_)
    {
        thirdScoreNum_ = secondScoreNum_;
        secondScoreNum_ = gameHud.gameScore;

        memcpy(thirdName_, secondName_, NAME_STRING_LENGTH_);
        memcpy(secondName_, newScoreName, NAME_STRING_LENGTH_);

    }
    else if(gameHud.gameScore > thirdScoreNum_)
    {
        thirdScoreNum_ = gameHud.gameScore;

        memcpy(thirdName_, newScoreName, NAME_STRING_LENGTH_);
    }
}

u8 isHighScore()
{
    if(gameHud.gameScore > thirdScoreNum_)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }    
}