#include "MainMenu.h"

#define MAIN_MENU_TEXT_LENGTH_ 10
#define START_GAME_ITEM_TEXT_LENGTH_ 11
#define OPTIONS_ITEM_TEXT_LENGTH_ 8
#define HIGHSCORES_ITEM_TEXT_LENGTH_ 12

const u8 MAIN_MENU_TITLE_TEXT_[MAIN_MENU_TEXT_LENGTH_] = "GAME MENU\0";
const u8 START_GAME_ITEM_TEXT_[START_GAME_ITEM_TEXT_LENGTH_] = "Start Game\0";
const u8 OPTIONS_ITEM_TEXT_[OPTIONS_ITEM_TEXT_LENGTH_] = "Options\0";
const u8 HGHSCORES_ITEM_TEXT_[HIGHSCORES_ITEM_TEXT_LENGTH_] = "High Scores\0";

Menu mainMenu;
MenuItem mainMenuItems_[MAIN_MENUITEM_COUNT];
MenuItem startGameMenuItem_;
MenuItem optionsMenuItem_;
MenuItem highScoresMenuItem_;

void runStartGame_();
void runOptionsMenu_();
void runHighScoresMenu_();

void buildMainMenu()
{
    //setup menu items
    initMenuItem(&startGameMenuItem_);
    initMenuItem(&optionsMenuItem_);
    initMenuItem(&highScoresMenuItem_);

    //set menu item text
    memcpy(startGameMenuItem_.itemText, START_GAME_ITEM_TEXT_, sizeof(u8)*START_GAME_ITEM_TEXT_LENGTH_);
    memcpy(optionsMenuItem_.itemText, OPTIONS_ITEM_TEXT_, sizeof(u8)*OPTIONS_ITEM_TEXT_LENGTH_);    
    memcpy(highScoresMenuItem_.itemText, HGHSCORES_ITEM_TEXT_, sizeof(u8)*HIGHSCORES_ITEM_TEXT_LENGTH_);

    //set menu item run functions
    startGameMenuItem_.runMenuItem = runStartGame_;
    optionsMenuItem_.runMenuItem = runOptionsMenu_;
    highScoresMenuItem_.runMenuItem = runHighScoresMenu_;

    //add menu itmes to array
    memcpy(&mainMenuItems_[0], &startGameMenuItem_, sizeof(MenuItem));
    memcpy(&mainMenuItems_[1], &optionsMenuItem_, sizeof(MenuItem));
    memcpy(&mainMenuItems_[2], &highScoresMenuItem_, sizeof(MenuItem));

    //set menu title
    memcpy(mainMenu.menuTitle, MAIN_MENU_TITLE_TEXT_, sizeof(u8)*MAIN_MENU_TEXT_LENGTH_);

    //add menuitems array to menu
    initMenu(&mainMenu, mainMenuItems_, MAIN_MENUITEM_COUNT);
}

void runMainMenu()
{
    runMenu(&mainMenu);
}

void runStartGame_()
{
    startMapManager();
}

void runOptionsMenu_()
{
    runMenu(&optionsMenu);
}

void runHighScoresMenu_()
{
    displayHighScores();
}